Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/SolutionPool2TierUpdateMethod.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/SolutionPool2TierUpdateMethod.cs	(revision 7785)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/SolutionPool2TierUpdateMethod.cs	(revision 7786)
@@ -36,11 +36,11 @@
   [Item("SolutionPool2TierUpdateMethod", "An operator that updates the solution pool using a 2-tier strategy.")]
   [StorableClass]
-  public sealed class SolutionPool2TierUpdateMethod : SingleSuccessorOperator, IScatterSearchTargetProcessor {
+  public sealed class SolutionPool2TierUpdateMethod : SingleSuccessorOperator {
     #region Parameter properties
     public ScopeParameter CurrentScopeParameter {
       get { return (ScopeParameter)Parameters["CurrentScope"]; }
     }
-    public IValueLookupParameter<DiversityCalculator> DiversityCalculatorParameter {
-      get { return (IValueLookupParameter<DiversityCalculator>)Parameters["DiversityCalculator"]; }
+    public IValueLookupParameter<SimilarityCalculator> SimilarityCalculatorParameter {
+      get { return (IValueLookupParameter<SimilarityCalculator>)Parameters["SimilarityCalculator"]; }
     }
     public IValueLookupParameter<BoolValue> MaximizationParameter {
@@ -53,9 +53,9 @@
       get { return (IValueLookupParameter<IntValue>)Parameters["NumberOfHighQualitySolutions"]; }
     }
+    public IValueLookupParameter<IItem> QualityParameter {
+      get { return (IValueLookupParameter<IItem>)Parameters["Quality"]; }
+    }
     public IValueLookupParameter<IntValue> ReferenceSetSizeParameter {
       get { return (IValueLookupParameter<IntValue>)Parameters["ReferenceSetSize"]; }
-    }
-    public IValueLookupParameter<IItem> QualityParameter {
-      get { return (IValueLookupParameter<IItem>)Parameters["Quality"]; }
     }
     public IValueLookupParameter<IItem> TargetParameter {
@@ -68,6 +68,6 @@
       get { return CurrentScopeParameter.ActualValue; }
     }
-    private DiversityCalculator DiversityCalculator {
-      get { return DiversityCalculatorParameter.ActualValue; }
+    private SimilarityCalculator SimilarityCalculator {
+      get { return SimilarityCalculatorParameter.ActualValue; }
     }
     private BoolValue Maximization {
@@ -81,10 +81,10 @@
       get { return NumberOfHighQualitySolutionsParameter.ActualValue; }
     }
+    private IItem Quality {
+      get { return QualityParameter.ActualValue; }
+    }
     private IntValue ReferenceSetSize {
       get { return ReferenceSetSizeParameter.ActualValue; }
       set { ReferenceSetSizeParameter.ActualValue = value; }
-    }
-    private IItem Quality {
-      get { return QualityParameter.ActualValue; }
     }
     private IItem Target {
@@ -105,18 +105,17 @@
       #region Create parameters
       Parameters.Add(new ScopeParameter("CurrentScope"));
-      Parameters.Add(new ValueLookupParameter<DiversityCalculator>("DiversityCalculator"));
       Parameters.Add(new ValueLookupParameter<BoolValue>("Maximization"));
       Parameters.Add(new ValueLookupParameter<BoolValue>("NewSolutions"));
       Parameters.Add(new ValueLookupParameter<IntValue>("NumberOfHighQualitySolutions"));
+      Parameters.Add(new ValueLookupParameter<IItem>("Quality"));
       Parameters.Add(new ValueLookupParameter<IntValue>("ReferenceSetSize"));
-      Parameters.Add(new ValueLookupParameter<IItem>("Quality"));
+      Parameters.Add(new ValueLookupParameter<SimilarityCalculator>("SimilarityCalculator"));
       Parameters.Add(new ValueLookupParameter<IItem>("Target"));
       #endregion
-      TargetParameter.ActualName = "KnapsackSolution"; // temporary solution for the knapsack problem
     }
 
     public override IOperation Apply() {
-      var parentsScope = new Scope("Parents");
-      var offspringScope = new Scope("Offspring");
+      IScope parentsScope = new Scope("Parents");
+      IScope offspringScope = new Scope("Offspring");
 
       // split parents and offspring
@@ -132,24 +131,20 @@
 
       var highQualityParents = orderedParents.Take(NumberOfHighQualitySolutions.Value).ToList();
-      var highDiversityParents = new List<Tuple<IScope, double>>();
+      IList<Tuple<IScope, double>> highSimilarityParents = new List<Tuple<IScope, double>>();
       foreach (var oScope in orderedParents.Skip(NumberOfHighQualitySolutions.Value)) {
-        double diversity = 0.0;
-        var oSol = oScope.Variables[TargetParameter.ActualName].Value;
+        double similarity = 0.0;
         foreach (var hScope in highQualityParents) {
-          var hSol = hScope.Variables[TargetParameter.ActualName].Value;
-          diversity += DiversityCalculator.ExecuteCalculation(oSol, hSol);
+          similarity += SimilarityCalculator.ExecuteCalculation(oScope, hScope);
         }
-        highDiversityParents.Add(new Tuple<IScope, double>(oScope, diversity));
+        highSimilarityParents.Add(new Tuple<IScope, double>(oScope, similarity));
       }
 
-      var offspring = new List<Tuple<IScope, double>>();
+      IList<Tuple<IScope, double>> offspring = new List<Tuple<IScope, double>>();
       foreach (var oScope in orderedOffspring) {
-        double diversity = 0.0;
-        var oSol = oScope.Variables[TargetParameter.ActualName].Value;
+        double similarity = 0.0;
         foreach (var hScope in highQualityParents) {
-          var hSol = hScope.Variables[TargetParameter.ActualName].Value;
-          diversity += DiversityCalculator.ExecuteCalculation(oSol, hSol);
+          similarity += SimilarityCalculator.ExecuteCalculation(oScope, hScope);
         }
-        offspring.Add(new Tuple<IScope, double>(oScope, diversity));
+        offspring.Add(new Tuple<IScope, double>(oScope, similarity));
       }
 
@@ -171,36 +166,20 @@
 
       // update diversity part of the reference set
-      var hasBetterDiversity = (Func<Tuple<IScope, double>, bool>)(x => { return x.Item2 > highDiversityParents.OrderBy(y => y.Item2).First().Item2; });
+      var hasBetterDiversity = (Func<Tuple<IScope, double>, bool>)(x => { return x.Item2 < highSimilarityParents.OrderByDescending(y => y.Item2).First().Item2; });
       if (offspring.Any(hasBetterDiversity)) NewSolutions.Value = true;
       while (offspring.Any(hasBetterDiversity)) { // better offspring available
         // select best offspring
-        var bestChild = offspring.OrderByDescending(x => x.Item2).First();
+        var bestChild = offspring.OrderBy(x => x.Item2).First();
         // select worst parent
-        var worstParent = highDiversityParents.OrderBy(x => x.Item2).First();
-        highDiversityParents.Remove(worstParent);
-        highDiversityParents.Add(bestChild);
+        var worstParent = highSimilarityParents.OrderByDescending(x => x.Item2).First();
+        highSimilarityParents.Remove(worstParent);
+        highSimilarityParents.Add(bestChild);
         offspring.Remove(bestChild);
       }
 
-      CurrentScope.SubScopes.Replace(highQualityParents.Concat(highDiversityParents.Select(x => x.Item1)).ToList());
+      CurrentScope.SubScopes.Replace(highQualityParents.Concat(highSimilarityParents.Select(x => x.Item1)).ToList());
 
       return base.Apply();
     }
-
-    private class KeyEqualityComparer<T> : IEqualityComparer<T> {
-      private readonly Func<T, object> keyExtractor;
-
-      public KeyEqualityComparer(Func<T, object> keyExtractor) {
-        this.keyExtractor = keyExtractor;
-      }
-
-      public bool Equals(T x, T y) {
-        return keyExtractor(x).Equals(keyExtractor(y));
-      }
-
-      public int GetHashCode(T obj) {
-        return keyExtractor(obj).GetHashCode();
-      }
-    }
   }
 }
Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/SolutionPoolUpdateMethod.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/SolutionPoolUpdateMethod.cs	(revision 7785)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/SolutionPoolUpdateMethod.cs	(revision 7786)
@@ -36,5 +36,5 @@
   [Item("SolutionPoolUpdateMethod", "An operator that updates the solution pool.")]
   [StorableClass]
-  public sealed class SolutionPoolUpdateMethod : SingleSuccessorOperator, IScatterSearchTargetProcessor {
+  public sealed class SolutionPoolUpdateMethod : SingleSuccessorOperator {
     #region Parameter properties
     public ScopeParameter CurrentScopeParameter {
@@ -47,9 +47,12 @@
       get { return (IValueLookupParameter<BoolValue>)Parameters["NewSolutions"]; }
     }
+    public IValueLookupParameter<IItem> QualityParameter {
+      get { return (IValueLookupParameter<IItem>)Parameters["Quality"]; }
+    }
     public IValueLookupParameter<IntValue> ReferenceSetSizeParameter {
       get { return (IValueLookupParameter<IntValue>)Parameters["ReferenceSetSize"]; }
     }
-    public IValueLookupParameter<IItem> QualityParameter {
-      get { return (IValueLookupParameter<IItem>)Parameters["Quality"]; }
+    public IValueLookupParameter<SimilarityCalculator> SimilarityCalculatorParameter {
+      get { return (IValueLookupParameter<SimilarityCalculator>)Parameters["SimilarityCalculator"]; }
     }
     public IValueLookupParameter<IItem> TargetParameter {
@@ -69,10 +72,13 @@
       get { return NewSolutionsParameter.ActualValue; }
     }
+    private IItem Quality {
+      get { return QualityParameter.ActualValue; }
+    }
     private IntValue ReferenceSetSize {
       get { return ReferenceSetSizeParameter.ActualValue; }
       set { ReferenceSetSizeParameter.ActualValue = value; }
     }
-    private IItem Quality {
-      get { return QualityParameter.ActualValue; }
+    private SimilarityCalculator SimilarityCalculator {
+      get { return SimilarityCalculatorParameter.ActualValue; }
     }
     private IItem Target {
@@ -95,14 +101,14 @@
       Parameters.Add(new ValueLookupParameter<BoolValue>("Maximization"));
       Parameters.Add(new ValueLookupParameter<BoolValue>("NewSolutions"));
+      Parameters.Add(new ValueLookupParameter<IItem>("Quality"));
       Parameters.Add(new ValueLookupParameter<IntValue>("ReferenceSetSize"));
-      Parameters.Add(new ValueLookupParameter<IItem>("Quality"));
+      Parameters.Add(new ValueLookupParameter<SimilarityCalculator>("SimilarityCalculator"));
       Parameters.Add(new ValueLookupParameter<IItem>("Target"));
       #endregion
-      TargetParameter.ActualName = "KnapsackSolution"; // temporary solution for the knapsack problem
     }
 
     public override IOperation Apply() {
-      var parentsScope = new Scope("Parents");
-      var offspringScope = new Scope("Offspring");
+      IScope parentsScope = new Scope("Parents");
+      IScope offspringScope = new Scope("Offspring");
 
       // split parents and offspring
@@ -121,8 +127,8 @@
       CurrentScope.SubScopes.AddRange(orderedParents);
 
-      var worstParentQuality = (orderedParents.Last().Variables[QualityParameter.ActualName].Value as DoubleValue).Value;
+      double worstParentQuality = (orderedParents.Last().Variables[QualityParameter.ActualName].Value as DoubleValue).Value;
 
       var hasBetterQuality = Maximization.Value ? (Func<IScope, bool>)(x => { return (x.Variables[QualityParameter.ActualName].Value as DoubleValue).Value > worstParentQuality; }) :
-                                            (Func<IScope, bool>)(x => { return (x.Variables[QualityParameter.ActualName].Value as DoubleValue).Value < worstParentQuality; });
+                                                  (Func<IScope, bool>)(x => { return (x.Variables[QualityParameter.ActualName].Value as DoubleValue).Value < worstParentQuality; });
 
       // is there any offspring better than the worst parent?
@@ -130,5 +136,5 @@
         // produce the set union
         // attention: distinction might cause a too small reference set! (e.g. reference set = {1, 2, 2, 2, ..., 2} -> union = {1, 2}
-        var union = orderedParents.Union(orderedOffspring.Where(hasBetterQuality), new KeyEqualityComparer<IScope>(x => x.Variables[TargetParameter.ActualName].Value.ToString()));
+        var union = orderedParents.Union(orderedOffspring.Where(hasBetterQuality), new SolutionEqualityComparer<IScope>(SimilarityCalculator.ExecuteCalculation));
         if (union.Count() > orderedParents/*.Distinct(new KeyEqualityComparer<IScope>(x => x.Variables[TargetParameter.ActualName].Value.ToString()))*/.Count()) {
           var orderedUnion = Maximization.Value ? union.OrderByDescending(x => x.Variables[QualityParameter.ActualName].Value) :
@@ -142,17 +148,17 @@
     }
 
-    private class KeyEqualityComparer<T> : IEqualityComparer<T> {
-      private readonly Func<T, object> keyExtractor;
+    private class SolutionEqualityComparer<T> : EqualityComparer<T> {
+      private readonly Func<T, T, double> diversityCalculator;
 
-      public KeyEqualityComparer(Func<T, object> keyExtractor) {
-        this.keyExtractor = keyExtractor;
+      public SolutionEqualityComparer(Func<T, T, double> diversityCalculator) {
+        this.diversityCalculator = diversityCalculator;
       }
 
-      public bool Equals(T x, T y) {
-        return keyExtractor(x).Equals(keyExtractor(y));
+      public override bool Equals(T x, T y) {
+        return diversityCalculator(x, y) == 0.0;
       }
 
-      public int GetHashCode(T obj) {
-        return keyExtractor(obj).GetHashCode();
+      public override int GetHashCode(T obj) {
+        return obj.GetHashCode();
       }
     }
Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsImprovementOperator.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsImprovementOperator.cs	(revision 7785)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsImprovementOperator.cs	(revision 7786)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Reflection;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -26,8 +27,6 @@
 using HeuristicLab.Encodings.RealVectorEncoding;
 using HeuristicLab.Operators;
-using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Problems.Knapsack;
 using HeuristicLab.Problems.TestFunctions;
 
@@ -38,27 +37,24 @@
   [Item("TestFunctionsImprovementOperator", "An operator that improves test functions solutions.")]
   [StorableClass]
-  public abstract class TestFunctionsImprovementOperator : SingleSuccessorOperator, ILocalImprovementOperator, IScatterSearchTargetProcessor {
-    #region Problem properties
-    public Type ProblemType {
-      get { return typeof(KnapsackProblem); }
-    }
-    [Storable]
-    private KnapsackProblem problem;
-    public IProblem Problem {
-      get { return problem; }
-      set { problem = (KnapsackProblem)value; }
-    }
-    #endregion
-
+  public sealed class TestFunctionsImprovementOperator : SingleSuccessorOperator, IImprovementOperator {
     #region Parameter properties
+    public IValueParameter<DoubleValue> AlphaParameter {
+      get { return (IValueParameter<DoubleValue>)Parameters["Alpha"]; }
+    }
+    public IValueParameter<DoubleValue> BetaParameter {
+      get { return (IValueParameter<DoubleValue>)Parameters["Beta"]; }
+    }
     public ScopeParameter CurrentScopeParameter {
       get { return (ScopeParameter)Parameters["CurrentScope"]; }
     }
-    public IValueLookupParameter<DoubleMatrix> CoordinatesParameter {
-      get { return (IValueLookupParameter<DoubleMatrix>)Parameters["Coordinates"]; }
+    public IValueParameter<DoubleValue> DeltaParameter {
+      get { return (IValueParameter<DoubleValue>)Parameters["Delta"]; }
     }
     public IValueLookupParameter<ISingleObjectiveTestFunctionProblemEvaluator> EvaluatorParameter {
       get { return (IValueLookupParameter<ISingleObjectiveTestFunctionProblemEvaluator>)Parameters["Evaluator"]; }
     }
+    public IValueParameter<DoubleValue> GammaParameter {
+      get { return (IValueParameter<DoubleValue>)Parameters["Gamma"]; }
+    }
     public IValueLookupParameter<IntValue> ImprovementAttemptsParameter {
       get { return (IValueLookupParameter<IntValue>)Parameters["ImprovementAttempts"]; }
@@ -70,33 +66,7 @@
       get { return (IValueLookupParameter<IItem>)Parameters["Target"]; }
     }
-    public IValueParameter<DoubleValue> AlphaParameter {
-      get { return (IValueParameter<DoubleValue>)Parameters["Alpha"]; }
-    }
-    public IValueParameter<DoubleValue> BetaParameter {
-      get { return (IValueParameter<DoubleValue>)Parameters["Beta"]; }
-    }
-    public IValueParameter<DoubleValue> GammaParameter {
-      get { return (IValueParameter<DoubleValue>)Parameters["Gamma"]; }
-    }
-    public IValueParameter<DoubleValue> DeltaParameter {
-      get { return (IValueParameter<DoubleValue>)Parameters["Delta"]; }
-    }
-    #region ILocalImprovementOperator Parameters
-    public IValueLookupParameter<IntValue> MaximumIterationsParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["MaximumIterations"]; }
-    }
-    public ILookupParameter<IntValue> EvaluatedSolutionsParameter {
-      get { return (ILookupParameter<IntValue>)Parameters["EvaluatedSolutions"]; }
-    }
-    public ILookupParameter<ResultCollection> ResultsParameter {
-      get { return (ILookupParameter<ResultCollection>)Parameters["Results"]; }
-    }
     #endregion
-    #endregion
 
     #region Properties
-    private IItem Target {
-      get { return TargetParameter.ActualValue; }
-    }
     private DoubleValue Alpha {
       get { return AlphaParameter.Value; }
@@ -105,17 +75,9 @@
       get { return BetaParameter.Value; }
     }
-    private DoubleValue Gamma {
-      get { return GammaParameter.Value; }
+    public IScope CurrentScope {
+      get { return CurrentScopeParameter.ActualValue; }
     }
     private DoubleValue Delta {
       get { return DeltaParameter.Value; }
-    }
-    protected Func<RealVector, double> FunctionEvaluator { get; set; }
-    public IScope CurrentScope {
-      get { return CurrentScopeParameter.ActualValue; }
-    }
-    public DoubleMatrix Coordinates {
-      get { return CoordinatesParameter.ActualValue; }
-      set { CoordinatesParameter.ActualValue = value; }
     }
     public ISingleObjectiveTestFunctionProblemEvaluator Evaluator {
@@ -123,4 +85,7 @@
       set { EvaluatorParameter.ActualValue = value; }
     }
+    private DoubleValue Gamma {
+      get { return GammaParameter.Value; }
+    }
     public IntValue ImprovementAttempts {
       get { return ImprovementAttemptsParameter.ActualValue; }
@@ -131,35 +96,43 @@
       set { RandomParameter.ActualValue = value; }
     }
+    private IItem Target {
+      get { return TargetParameter.ActualValue; }
+    }
     #endregion
 
     [StorableConstructor]
-    protected TestFunctionsImprovementOperator(bool deserializing) : base(deserializing) { }
-    protected TestFunctionsImprovementOperator(TestFunctionsImprovementOperator original, Cloner cloner)
-      : base(original, cloner) {
-      this.problem = cloner.Clone(original.problem);
-    }
+    private TestFunctionsImprovementOperator(bool deserializing) : base(deserializing) { }
+    private TestFunctionsImprovementOperator(TestFunctionsImprovementOperator original, Cloner cloner) : base(original, cloner) { }
     public TestFunctionsImprovementOperator()
       : base() {
       #region Create parameters
-      Parameters.Add(new ScopeParameter("CurrentScope"));
-      Parameters.Add(new ValueLookupParameter<DoubleMatrix>("Coordinates"));
-      Parameters.Add(new ValueLookupParameter<ISingleObjectiveTestFunctionProblemEvaluator>("Evaluator"));
-      Parameters.Add(new ValueLookupParameter<IntValue>("ImprovementAttempts", new IntValue(100)));
-      Parameters.Add(new ValueLookupParameter<IRandom>("Random"));
-      Parameters.Add(new ValueLookupParameter<IItem>("Target"));
       Parameters.Add(new ValueParameter<DoubleValue>("Alpha", new DoubleValue(1.0)));
       Parameters.Add(new ValueParameter<DoubleValue>("Beta", new DoubleValue(2.0)));
+      Parameters.Add(new ScopeParameter("CurrentScope"));
+      Parameters.Add(new ValueParameter<DoubleValue>("Delta", new DoubleValue(0.5)));
+      Parameters.Add(new ValueLookupParameter<ISingleObjectiveTestFunctionProblemEvaluator>("Evaluator"));
       Parameters.Add(new ValueParameter<DoubleValue>("Gamma", new DoubleValue(0.5)));
-      Parameters.Add(new ValueParameter<DoubleValue>("Delta", new DoubleValue(0.5)));
+      Parameters.Add(new ValueLookupParameter<IntValue>("ImprovementAttempts", new IntValue(100)));
+      Parameters.Add(new ValueLookupParameter<IItem>("Target"));
+      Parameters.Add(new ValueLookupParameter<IRandom>("Random"));
       #endregion
       TargetParameter.ActualName = "Point"; // temporary solution for the test functions problem
     }
 
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TestFunctionsImprovementOperator(this, cloner);
+    }
+
     public override IOperation Apply() {
-      var bestSol = CurrentScope.Variables[TargetParameter.ActualName].Value as RealVector;
-      var bestSolQuality = FunctionEvaluator(bestSol);
+      RealVector bestSol = CurrentScope.Variables[TargetParameter.ActualName].Value as RealVector;
+      MethodInfo evaluationMethod = Evaluator.GetType().GetMethod("Apply",
+                                                                  BindingFlags.Public | BindingFlags.Static,
+                                                                  null,
+                                                                  new Type[] { typeof(RealVector) }, null);
+      Func<RealVector, double> functionEvaluator = x => (double)evaluationMethod.Invoke(Evaluator, new object[] { x });
+      double bestSolQuality = functionEvaluator(bestSol);
 
       // create perturbed solutions
-      var simplex = new RealVector[bestSol.Length];
+      RealVector[] simplex = new RealVector[bestSol.Length];
       for (int i = 0; i < simplex.Length; i++) {
         simplex[i] = bestSol.Clone() as RealVector;
@@ -172,8 +145,8 @@
       for (int i = 0; i < ImprovementAttempts.Value; i++) {
         // order according to their objective function value
-        Array.Sort(simplex, (x, y) => FunctionEvaluator(x).CompareTo(FunctionEvaluator(y)));
+        Array.Sort(simplex, (x, y) => functionEvaluator(x).CompareTo(functionEvaluator(y)));
 
         // calculate centroid
-        var centroid = new RealVector(bestSol.Length);
+        RealVector centroid = new RealVector(bestSol.Length);
         foreach (var vector in simplex)
           for (int j = 0; j < centroid.Length; j++)
@@ -183,33 +156,33 @@
 
         // reflection
-        var reflectionPoint = new RealVector(bestSol.Length);
+        RealVector reflectionPoint = new RealVector(bestSol.Length);
         for (int j = 0; j < reflectionPoint.Length; j++)
           reflectionPoint[j] = centroid[j] + Alpha.Value * (centroid[j] - simplex[simplex.Length - 1][j]);
-        double reflectionPointQuality = FunctionEvaluator(reflectionPoint);
-        if (FunctionEvaluator(simplex[0]) <= reflectionPointQuality
-            && reflectionPointQuality < FunctionEvaluator(simplex[simplex.Length - 2]))
+        double reflectionPointQuality = functionEvaluator(reflectionPoint);
+        if (functionEvaluator(simplex[0]) <= reflectionPointQuality
+            && reflectionPointQuality < functionEvaluator(simplex[simplex.Length - 2]))
           simplex[simplex.Length - 1] = reflectionPoint;
 
         // expansion
-        if (reflectionPointQuality < FunctionEvaluator(simplex[0])) {
-          var expansionPoint = new RealVector(bestSol.Length);
+        if (reflectionPointQuality < functionEvaluator(simplex[0])) {
+          RealVector expansionPoint = new RealVector(bestSol.Length);
           for (int j = 0; j < expansionPoint.Length; j++)
             expansionPoint[j] = centroid[j] + Beta.Value * (reflectionPoint[j] - centroid[j]);
-          simplex[simplex.Length - 1] = FunctionEvaluator(expansionPoint) < reflectionPointQuality ? expansionPoint : reflectionPoint;
+          simplex[simplex.Length - 1] = functionEvaluator(expansionPoint) < reflectionPointQuality ? expansionPoint : reflectionPoint;
         }
 
         // contraction
-        if (FunctionEvaluator(simplex[simplex.Length - 2]) <= reflectionPointQuality
-            && reflectionPointQuality < FunctionEvaluator(simplex[simplex.Length - 1])) {
-          var outsideContractionPoint = new RealVector(bestSol.Length);
+        if (functionEvaluator(simplex[simplex.Length - 2]) <= reflectionPointQuality
+            && reflectionPointQuality < functionEvaluator(simplex[simplex.Length - 1])) {
+          RealVector outsideContractionPoint = new RealVector(bestSol.Length);
           for (int j = 0; j < outsideContractionPoint.Length; j++)
             outsideContractionPoint[j] = centroid[j] + Gamma.Value * (reflectionPoint[j] - centroid[j]);
-          if (FunctionEvaluator(outsideContractionPoint) <= reflectionPointQuality) {
+          if (functionEvaluator(outsideContractionPoint) <= reflectionPointQuality) {
             simplex[simplex.Length - 1] = outsideContractionPoint;
-            if (FunctionEvaluator(reflectionPoint) >= FunctionEvaluator(simplex[simplex.Length - 1])) {
-              var insideContractionPoint = new RealVector(bestSol.Length);
+            if (functionEvaluator(reflectionPoint) >= functionEvaluator(simplex[simplex.Length - 1])) {
+              RealVector insideContractionPoint = new RealVector(bestSol.Length);
               for (int j = 0; j < insideContractionPoint.Length; j++)
                 insideContractionPoint[j] = centroid[j] - Gamma.Value * (reflectionPoint[j] - centroid[j]);
-              if (FunctionEvaluator(insideContractionPoint) < FunctionEvaluator(simplex[simplex.Length - 1])) simplex[simplex.Length - 1] = insideContractionPoint;
+              if (functionEvaluator(insideContractionPoint) < functionEvaluator(simplex[simplex.Length - 1])) simplex[simplex.Length - 1] = insideContractionPoint;
             }
           }
Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsPathRelinker.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsPathRelinker.cs	(revision 7785)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsPathRelinker.cs	(revision 7786)
@@ -71,13 +71,13 @@
         throw new ArgumentException("RelinkingAccuracy must be greater than 0.");
 
-      var v1 = initiator.Clone() as RealVector;
-      var v2 = guide as RealVector;
+      RealVector v1 = initiator.Clone() as RealVector;
+      RealVector v2 = guide as RealVector;
 
       if (v1.Length != v2.Length)
         throw new ArgumentException("The solutions are of different length.");
 
-      var solutions = new List<RealVector>();
+      IList<RealVector> solutions = new List<RealVector>();
       for (int i = 0; i < k.Value; i++) {
-        var solution = v1.Clone() as RealVector;
+        RealVector solution = v1.Clone() as RealVector;
         for (int j = 0; j < solution.Length; j++)
           solution[j] = v1[j] + 1 / (k.Value - i) * (v2[j] - v1[j]);
@@ -85,11 +85,11 @@
       }
 
-      var selection = new List<IItem>();
+      IList<IItem> selection = new List<IItem>();
       if (solutions.Count > 0) {
-        var noSol = (int)Math.Round(solutions.Count * n.Value);
+        int noSol = (int)(solutions.Count * n.Value);
         if (noSol <= 0) noSol++;
-        var stepSize = (double)solutions.Count / (double)noSol;
+        double stepSize = (double)solutions.Count / (double)noSol;
         for (int i = 0; i < noSol; i++)
-          selection.Add(solutions.ElementAt((int)Math.Round((i + 1) * stepSize - stepSize * 0.5)));
+          selection.Add(solutions.ElementAt((int)((i + 1) * stepSize - stepSize * 0.5)));
       }
 
Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsSimilarityCalculator.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsSimilarityCalculator.cs	(revision 7786)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsSimilarityCalculator.cs	(revision 7786)
@@ -0,0 +1,81 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.ScatterSearch.TestFunctions {
+  /// <summary>
+  /// An operator that performs similarity calculation between two test functions solutions.
+  /// </summary>
+  [Item("TestFunctionsSimilarityCalculator", "An operator that performs similarity calculation between two test functions solutions.")]
+  [StorableClass]
+  public sealed class TestFunctionsSimilarityCalculator : SimilarityCalculator {
+    #region Parameter properties
+    public ILookupParameter<DoubleMatrix> BoundsParameter {
+      get { return (ILookupParameter<DoubleMatrix>)Parameters["Bounds"]; }
+    }
+    #endregion
+
+    #region Properties
+    private DoubleMatrix Bounds {
+      get { return BoundsParameter.ActualValue; }
+      set { BoundsParameter.ActualValue = value; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    private TestFunctionsSimilarityCalculator(bool deserializing) : base(deserializing) { }
+    private TestFunctionsSimilarityCalculator(TestFunctionsSimilarityCalculator original, Cloner cloner) : base(original, cloner) { }
+    public TestFunctionsSimilarityCalculator()
+      : base() {
+      #region Create parameters
+      Parameters.Add(new LookupParameter<DoubleMatrix>("Bounds"));
+      #endregion
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TestFunctionsSimilarityCalculator(this, cloner);
+    }
+
+    protected override double CalculateDiversity(IScope left, IScope right) {
+      RealVector sol1 = left.Variables["Point"].Value as RealVector;
+      RealVector sol2 = right.Variables["Point"].Value as RealVector;
+
+      double maxSum = 0.0;
+      for (int i = 0; i < sol1.Length; i++)
+        maxSum += Math.Pow(Bounds[0, 0] - Bounds[0, 1], 2);
+      double maxDistance = Math.Sqrt(maxSum) / sol1.Length;
+
+      double sum = 0.0;
+      for (int i = 0; i < sol1.Length; i++)
+        sum += Math.Pow(sol1[i] - sol2[i], 2);
+      double distance = Math.Sqrt(sum) / sol1.Length;
+
+      return 1.0 - distance / maxDistance;
+    }
+  }
+}
